﻿using Infragistics.Controls.Menus;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.Xml;
using DataUtil_BindToClass;
using Infragistics.Documents.Excel;
using Microsoft.Win32;
using System.IO;

namespace WPF_xamDataTree
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {       
        public MainWindow()
        {
            InitializeComponent();
           
        }

        private void NewRootNodeMenuItem_Click(object sender, RoutedEventArgs e)
        {
            MessageBox.Show("NewRootNodeMenuItem_Click");
        }

        private void btn_Click(object sender, RoutedEventArgs e)
        {            
            this.SaveExport(this.CreateWorkbook());
        }


        private void SaveExport(Workbook dataWorkbook)
        {
            SaveFileDialog dialog = new SaveFileDialog
            {
                Filter = "Excel files|*.xls",
                DefaultExt = "xls"
            };

            bool? showDialog = dialog.ShowDialog();
            if (showDialog == true)
            {
                using (Stream exportStream = dialog.OpenFile())
                {
                    dataWorkbook.Save(exportStream);
                    exportStream.Close();
                }
            }
        }

        private Workbook CreateWorkbook()
        {

            
            //Create the blank workbook and the sheet in it that will contain the XamDataTree data
            Workbook dataWorkbook = new Workbook();
            Worksheet sheetOne = dataWorkbook.Worksheets.Add("Data from XamDataTree");

            //Freeze header rows and columns
            sheetOne.DisplayOptions.PanesAreFrozen = true;       

            //Set default width for the columns
            sheetOne.DefaultColumnWidth = 5000;

            int currentColumn, currentRow;
            string currentCellValue;

            currentRow = 0;

            for (int i = 0; i < xamDataTree.Nodes.Count; i++)
            {
                XamDataTreeNode catgitem = xamDataTree.Nodes[i];
                //catgNames.Add(((catgitem as XamDataTreeNode).Data as Category).CategoryName);               
                currentColumn = 0;
                currentCellValue = ((catgitem as XamDataTreeNode).Data as Category).CategoryName;
                                
                this.SetCellValue(
                        sheetOne.Rows[currentRow] 
                            .Cells[currentColumn],
                        currentCellValue,
                        "Data");

                if (catgitem.Nodes.Count > 0)
                {
                    for (int ci = 0; ci < catgitem.Nodes.Count; ci++)
                    {
                        XamDataTreeNode proditem = catgitem.Nodes[ci];
                        currentRow++;
                        currentColumn = 1;
                       
                        currentCellValue = ((proditem as XamDataTreeNode).Data as Product).ProductName;
                      
                        this.SetCellValue(
                                sheetOne.Rows[currentRow]
                                    .Cells[currentColumn],
                                currentCellValue,
                                "Data");
                    }
                }

                //increment row for next parent node
                currentRow++;
            }  

            //return the filled in workbook
            return dataWorkbook;
        }

        //Set the value and format each cell
        private void SetCellValue(WorksheetCell cell, string CellValue, string CellType)
        {
            cell.Value = CellValue;
            cell.CellFormat.ShrinkToFit = ExcelDefaultableBoolean.False;
            cell.CellFormat.VerticalAlignment = VerticalCellAlignment.Center;
            cell.CellFormat.Alignment = HorizontalCellAlignment.Left;

            //if (CellType == "TopHeader")
            //{
            //    cell.CellFormat.FillPatternForegroundColor = new Color()
            //    {
            //        A = 255,
            //        R = 181,
            //        G = 212,
            //        B = 240
            //    };
            //    cell.CellFormat.FillPattern = FillPatternStyle.Solid;
            //}
            //else if (CellType == "LeftHeader")
            //{
            //    cell.CellFormat.FillPatternForegroundColor = new Color()
            //    {
            //        A = 255,
            //        R = 200,
            //        G = 212,
            //        B = 240
            //    };
            //    cell.CellFormat.FillPattern = FillPatternStyle.Solid;
            //}
            //else if (CellType == "Data")
            //{
            //    cell.CellFormat.FillPatternForegroundColor = new Color()
            //    {
            //        A = 255,
            //        R = 242,
            //        G = 244,
            //        B = 249
            //    };
            //    cell.CellFormat.FillPattern = FillPatternStyle.Solid;
            //}
            //else
            //{
            //    MessageBox.Show("Cell Type Not Located");
            //}
        }



        
    }

   

}
